pcl::octree::OctreeLeafNodeIterator< OctreeT > Class Template Reference
Module octree

Octree leaf node iterator class. More...

`#include <pcl/octree/octree_iterator.h>`

Inheritance diagram for pcl::octree::OctreeLeafNodeIterator< OctreeT >:

## Public Member Functions

| OctreeLeafNodeIterator (unsigned int max_depth_arg=0)
| Empty constructor. More...
| OctreeLeafNodeIterator (OctreeT *octree_arg, unsigned int max_depth_arg=0)
| Constructor. More...
virtual | ~OctreeLeafNodeIterator ()
| Empty deconstructor. More...
void | reset ()
| Reset the iterator to the root node of the octree. More...
OctreeLeafNodeIterator & | operator++ ()
| Preincrement operator. More...
OctreeLeafNodeIterator | operator++ (int)
| postincrement operator. More...
OctreeNode * | operator* () const
| *operator. More...
Public Member Functions inherited from pcl::octree::OctreeDepthFirstIterator< OctreeT >
| OctreeDepthFirstIterator (unsigned int max_depth_arg=0)
| Empty constructor. More...
| OctreeDepthFirstIterator (OctreeT *octree_arg, unsigned int max_depth_arg=0)
| Constructor. More...
virtual | ~OctreeDepthFirstIterator ()
| Empty deconstructor. More...
OctreeDepthFirstIterator & | operator= (const OctreeDepthFirstIterator &src)
| Copy operator. More...
OctreeDepthFirstIterator & | operator++ ()
| Preincrement operator. More...
OctreeDepthFirstIterator | operator++ (int)
| postincrement operator. More...
void | skipChildVoxels ()
| Skip all child voxels of current node and return to parent node. More...
Public Member Functions inherited from pcl::octree::OctreeIteratorBase< OctreeT >
| OctreeIteratorBase (unsigned int max_depth_arg=0)
| Empty constructor. More...
| OctreeIteratorBase (OctreeT *octree_arg, unsigned int max_depth_arg=0)
| Constructor. More...
| OctreeIteratorBase (const OctreeIteratorBase &src, unsigned int max_depth_arg=0)
| Copy constructor. More...
OctreeIteratorBase & | operator= (const OctreeIteratorBase &src)
| Copy operator. More...
virtual | ~OctreeIteratorBase ()
| Empty deconstructor. More...
bool | operator== (const OctreeIteratorBase &other) const
| Equal comparison operator. More...
bool | operator!= (const OctreeIteratorBase &other) const
| Inequal comparison operator. More...
void | reset ()
| Reset iterator. More...
const OctreeKey & | getCurrentOctreeKey () const
| Get octree key for the current iterator octree node. More...
unsigned int | getCurrentOctreeDepth () const
| Get the current depth level of octree. More...
OctreeNode * | getCurrentOctreeNode () const
| Get the current octree node. More...
bool | isBranchNode () const
| check if current node is a branch node More...
bool | isLeafNode () const
| check if current node is a branch node More...
OctreeNode * | operator* () const
| *operator. More...
char | getNodeConfiguration () const
| Get bit pattern of children configuration of current node. More...
const LeafContainer & | getLeafContainer () const
| Method for retrieving a single leaf container from the octree leaf node. More...
LeafContainer & | getLeafContainer ()
| Method for retrieving a single leaf container from the octree leaf node. More...
const BranchContainer & | getBranchContainer () const
| Method for retrieving the container from an octree branch node. More...
BranchContainer & | getBranchContainer ()
| Method for retrieving the container from an octree branch node. More...
virtual unsigned long | getNodeID () const
| get a integer identifier for current node (note: identifier depends on tree depth). More...

## Additional Inherited Members

Public Types inherited from pcl::octree::OctreeDepthFirstIterator< OctreeT >
typedef OctreeIteratorBase< OctreeT >::LeafNode | LeafNode
typedef OctreeIteratorBase< OctreeT >::BranchNode | BranchNode
Public Types inherited from pcl::octree::OctreeIteratorBase< OctreeT >
typedef OctreeT::LeafNode | LeafNode
typedef OctreeT::BranchNode | BranchNode
typedef OctreeT::LeafContainer | LeafContainer
typedef OctreeT::BranchContainer | BranchContainer
Protected Attributes inherited from pcl::octree::OctreeDepthFirstIterator< OctreeT >
std::vector< IteratorState > | stack_
| Stack structure. More...
Protected Attributes inherited from pcl::octree::OctreeIteratorBase< OctreeT >
OctreeT * | octree_
| Reference to octree class. More...
IteratorState * | current_state_
| Pointer to current iterator state. More...
unsigned int | max_octree_depth_
| Maximum octree depth. More...

## Detailed Description

### template<typename OctreeT>
class pcl::octree::OctreeLeafNodeIterator< OctreeT >

Octree leaf node iterator class.

Note
  This class implements a forward iterator for traversing the leaf nodes of an octree data structure.

Author
  Julius Kammerl (juliu.nosp@m.s@ka.nosp@m.mmerl.nosp@m..de)

Definition at line 534 of file octree_iterator.h.

## Constructor & Destructor Documentation

## OctreeLeafNodeIterator() [1/2]

template<typename OctreeT >

pcl::octree::OctreeLeafNodeIterator< OctreeT >::OctreeLeafNodeIterator | ( | unsigned int | max_depth_arg = `0` | ) |

inline explicit

Empty constructor.

Parameters

  [in] | max_depth_arg | Depth limitation during traversal

Definition at line 544 of file octree_iterator.h.

## OctreeLeafNodeIterator() [2/2]

template<typename OctreeT >

pcl::octree::OctreeLeafNodeIterator< OctreeT >::OctreeLeafNodeIterator | ( | OctreeT * | octree_arg,
|  | unsigned int | max_depth_arg = `0`
| ) |  |

inline explicit

Constructor.

Parameters

  [in] | octree_arg | Octree to be iterated. Initially the iterator is set to its root node.
  [in] | max_depth_arg | Depth limitation during traversal

Definition at line 555 of file octree_iterator.h.

## ~OctreeLeafNodeIterator()

template<typename OctreeT >

virtual pcl::octree::OctreeLeafNodeIterator< OctreeT >::~OctreeLeafNodeIterator | ( |  | ) |

inline virtual

Empty deconstructor.

Definition at line 563 of file octree_iterator.h.

## Member Function Documentation

## operator*()

template<typename OctreeT >

OctreeNode* pcl::octree::OctreeLeafNodeIterator< OctreeT >::operator* | ( |  | ) | const

inline

*operator.

Returns
  pointer to the current octree leaf node

Definition at line 605 of file octree_iterator.h.

References pcl::octree::LEAF_NODE.

## operator++() [1/2]

template<typename OctreeT >

OctreeLeafNodeIterator& pcl::octree::OctreeLeafNodeIterator< OctreeT >::operator++ | ( |  | ) |

inline

Preincrement operator.

Note
  recursively step to next octree leaf node

Definition at line 580 of file octree_iterator.h.

References pcl::octree::LEAF_NODE, and pcl::octree::OctreeDepthFirstIterator< OctreeT >::operator++().

## operator++() [2/2]

template<typename OctreeT >

OctreeLeafNodeIterator pcl::octree::OctreeLeafNodeIterator< OctreeT >::operator++ | ( | int |  | ) |

inline

postincrement operator.

Note
  step to next octree node

Definition at line 594 of file octree_iterator.h.

## reset()

template<typename OctreeT >

void pcl::octree::OctreeLeafNodeIterator< OctreeT >::reset | ( |  | ) |

inline virtual

Reset the iterator to the root node of the octree.

Reimplemented from pcl::octree::OctreeDepthFirstIterator< OctreeT >.

Definition at line 570 of file octree_iterator.h.

References pcl::octree::OctreeDepthFirstIterator< OctreeT >::reset().

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/octree/include/pcl/octree/octree_iterator.h